# GPU Virtualizáció

A gpu kártyák virtualizációját megnehezíti, hogy a gyártók bár azonos alapokon nyugvó kártyákat fejlesztenek ki, a hozzájuk tartozó driver-ek többnyire zártak és nem nyújtanak egységes képet a kezeléshez. Továbbá a kártyák fejlődésével minden gyártó a maga által kitalált technológiai irányvonalat / újítást követi, ami nem teszi lehetővé ezen kártyák egységes kezelését.

## Osztályozás

A virtuálizációhoz hasonlóan itt is a használt technológiától függően különböző fajta GPU virtualizációkról beszélhetünk.

 - **GPU passthrough** (kakukktojás): Nem virtualizációs technológia, de a host os lehetővé teszi egy virtuális gépnek a közvetlen PCI bus-on történő kommunikációt a kártyával. Hátránya: egyszerre csak egy VM használhatja, a használat kötött. Kevés veszteség.

 - **távoli API alapú**: A virtuális gépen speciális API könyvtár segítségével kommunikálunk a host-on keresztül a kártyával. Az API könyvtár egy wrapperhez hasonlítható, a rendes GPU hívásokat a wapper továbbítja a host-ra és az ottani API (CUDA, OpenCL, OpenGL) adja meg az eredményt.
 Mivel a módszer megkerüli a hypervisor réteget, ezért elenyésző többletköltséggel jár. A támogatott API-k rögzítettek, más API használata esetén a host-ot is újra kell konfigurálni, vagy frissíteni kell a wrapper könyvtárat, ha új funkciók kerülnek hozzáadásra a host GPU könyvtárához. Példák: GVirtuS (CUDA), DS-CUDA (CUDA), de nemcsak GPGPU wrapper-ek vannak.

![távoli API](img/remoteAPI.png)

 - **Para- vagy teljes virtualizáció**: 

![Paravirtualizáció vagy teljes virtualizációs megoldás](img/fullvirt.png)

 - **hardveres virtualizáció**: 
![hardveres virtualizáció](img/hardwaresup.png)




# Források
 - Cheol-Ho Hong, Ivor Spence, and Dimitrios S. Nikolopoulos. 2017. GPU Virtualization and Scheduling Methods: A Comprehensive Survey. ACM Comput. Surv. 50, 3, Article 35 (May 2018), 37 pages. https://doi.org/10.1145/3068281